import QtQuick 1.1
import com.nokia.meego 1.0

Page {


    function updateTotal() {

        var convertedspeed;

        //read arg1-arg4 input values
        //  inspect the html file to get the field IDs
        var arg1 = parseFloat(kphText.text); //speed
        var arg5 = parseFloat(mphText.text); //speed

        var arg2 = parseFloat(reactionText.text); //time
        var arg3 = parseFloat(decelerationText.text);
        var arg4 = parseFloat(gradientText.text);

        arg1 = isNaN(arg1) ? 0 : arg1;
        arg2 = isNaN(arg2) ? 0 : arg2;
        arg3 = isNaN(arg3) ? 0 : arg3;
        arg4 = isNaN(arg4) ? 0 : arg4;
        arg5 = isNaN(arg5) ? 0 : arg5;

        if(arg1 == 0){
            convertedspeed = arg5 * 0.447;
        }else{
            convertedspeed = arg1 * 0.277;
        }

        var suma = (convertedspeed*arg2) + (convertedspeed*convertedspeed)/(2*(arg3 + (0.1*arg4)))+(2.4);
        sumLabel.text = ""+(new Number((suma).toFixed(2)));
    }

    Label {
        text: "Stopping Sight Distance Calculator"
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top: parent.top
        id: titleLabel
        anchors.margins: 20
        font.bold: true
    }

    Label {
        text: "Vehicle Speed"
        anchors.top: titleLabel.bottom
        anchors.margins: 20
        anchors.horizontalCenter: parent.horizontalCenter
        id: labelSpeed

    }

    TextField {
        id: mphText
        placeholderText: "MPH"
        anchors.left: parent.left
        anchors.top: labelSpeed.bottom
        anchors.margins: 20
        width: (parent.width/2)-40
        inputMethodHints: Qt.ImhDigitsOnly

    }

    TextField {
        id: kphText
        placeholderText: "KPH"
        anchors.right: parent.right
        anchors.top: labelSpeed.bottom
        anchors.margins: 20
        width: (parent.width/2)-40
        inputMethodHints: Qt.ImhDigitsOnly
    }


    Label {
        id: reactionLabel
        text: "Reaction time"
        anchors.left: parent.left
        anchors.margins: 20
        anchors.top: mphText.bottom
        height: reactionText.height
        verticalAlignment: Text.AlignVCenter
    }

    TextField {
        id: reactionText
        inputMethodHints: Qt.ImhDigitsOnly
        anchors.right: parent.right
        anchors.top: kphText.bottom
        anchors.margins: 20
        width: (parent.width/2)-40
        text: "1.50"
    }

    Label {
        id: decelerationLabel
        text: "Deceleration"
        anchors.left: parent.left
        anchors.margins: 20
        anchors.top: reactionLabel.bottom
        height: reactionText.height
        verticalAlignment: Text.AlignVCenter
    }


    TextField {
        id: decelerationText
        text: "4.41"
        inputMethodHints: Qt.ImhDigitsOnly
        anchors.right: parent.right
        anchors.top: reactionText.bottom
        anchors.margins: 20
        width: (parent.width/2)-40
    }


    Label {
        id: gradientLabel
        text: "Gradient"
        anchors.left: parent.left
        anchors.margins: 20
        anchors.top: decelerationLabel.bottom
        height: gradientText.height
        verticalAlignment: Text.AlignVCenter
    }

    TextField {
        id: gradientText
        inputMethodHints: Qt.ImhDigitsOnly
        anchors.right: parent.right
        anchors.top: decelerationText.bottom
        anchors.margins: 20
        width: (parent.width/2)-40
    }


    Button {
        id: defaultDeceleration
        onClicked: {
            reactionText.text = "1.50"
            decelerationText.text = "4.41"
        }
        text: "Default"
        anchors.left: parent.left
        anchors.top: gradientLabel.bottom
        anchors.margins: 20
        width: 200
    }

    Button {
        onClicked: {
            updateTotal();
        }
        text: "Update"
        anchors.right: parent.right
        anchors.top: gradientText.bottom
        anchors.margins: 20
        width: 200
        id: updateButton

    }

    Label {
        id: sumLabel
        font.pixelSize: 42
        font.bold: true
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.top:     updateButton.bottom
        anchors.margins: 40


    }

}
